/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/




#include "/lib/universal.glsl"

/* ------ outputs ------ */
out mat2x2 coord;

out vec4 tint;

/* ------ uniforms ------ */
uniform vec2 taaOffset;

uniform vec3 sunVector, sunVectorView;
uniform vec3 moonVector, moonVectorView;
uniform vec3 sunPosition, upPosition;

uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

void main() {
    coord[0] = (gl_TextureMatrix[0]*gl_MultiTexCoord0).xy; // keep compatibility
    tint    = gl_Color;

    vec4 pos = gl_Vertex;
    pos = transMAD(gbufferModelViewInverse, pos.xyz).xyzz;
    pos = transMAD(gbufferModelView, pos.xyz).xyzz;
    pos = transMAD(gl_ModelViewMatrix, pos.xyz).xyzz;

    gl_Position = pos.xyzz * diagonal4(gl_ProjectionMatrix) + vec4(0, 0, gl_ProjectionMatrix[3].z, 0);
    gl_Position.xy += taaOffset * gl_Position.w;
}