
/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



float rayleigh_phase(float cosTheta) {
    /*
  	float phase = 0.75 * (1.0 + sqr(cos_theta));
  	*/
    float phase = 0.8 * (1.4 + 0.5 * cosTheta);
    phase *= rcp(pi4);
  	return phase;
}

float cornettShanksMiePhase(float cosTheta, float g) {
  	float gg = g*g;
  	float p1 = 3.0 * (1.0 - gg) * rcp((pi * (2.0 + gg)));
  	float p2 = (1.0 + sqr(cosTheta)) * rcp(pow((1.0 + gg - 2.0 * g * cosTheta), 3.0/2.0));
  	float phase = p1 * p2;
  	phase *= rcp(pi4);
  	return max(phase, 0.0);
}

vec2 phaseFunction(float cosTheta) 
{ 
    return vec2(rayleigh_phase(cosTheta), cornettShanksMiePhase(cosTheta, mieG));
}