
/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/


/* ------ normals encoding ------ */
/* //dunno what but something about these encoders is kinda broken
vec2 encodeNormal(in vec3 normal) {
    normal.xy = normal.xy / dot(abs(normal), vec3(1.0)) + 0.00390625;
    normal.xy = normal.z <= 0.0 ? (1.0 - abs(normal.yx)) * sign(normal.xy) : normal.xy;
    return normal.xy * 0.5 + 0.5;
}
vec3 decodeNormal(in vec2 encodedNormal) {
    vec3 normal = vec3(0.0);
    encodedNormal = encodedNormal * 2.0 - 1.0;
    normal.xy = abs(encodedNormal);
    normal.z = 1.0 - normal.x - normal.y;
    normal.xy = (1.0 - normal.yx) * sign(encodedNormal);
    normal.xy = normal.z <= 0.0 ? normal.xy : encodedNormal;
    return normalize(normal.xyz);
}*/
vec2 encodeNormal(in vec3 normal) {
    normal.xy /= abs(normal.x) + abs(normal.y) + abs(normal.z);
    return (normal.z <= 0.0 ? (1.0 - abs(normal.yx)) * vec2(normal.x >= 0.0 ? 1.0 : -1.0, normal.y >= 0.0 ? 1.0 : -1.0) : normal.xy) * 0.5 + 0.5;
}
vec3 decodeNormal(in vec2 encodedNormal) {
    encodedNormal = encodedNormal * 2.0 - 1.0;
	vec3 normal = vec3(encodedNormal, 1.0 - abs(encodedNormal.x) - abs(encodedNormal.y));
	float t = max(-normal.z, 0.0);
	normal.xy += vec2(normal.x >= 0.0 ? -t : t, normal.y >= 0.0 ? -t : t);
	return normalize(normal);
}

/* ------ 2x8 to 1x16 encoding ------ */
float encode2x8(in vec2 toEnc) {
    uvec2 bitfield = uvec2(toEnc * 255.0 + 0.5);
    return float(bitfield.x | bitfield.y << 8u) / 65535.0;
}
vec2 decode2x8(in float toDec) {
    uint bitfield = uint(toDec * 65535.0);
    return vec2(bitfield & 255u, bitfield >> 8u) / 255.0;
}

/* ------ material id to 1x16 encoding ------ */
float encodeMatID16(int x) {
    float id    = float(x)/65535.0;
    return id;
}
int decodeMatID16(float x) {
    return int(x*65535.0);
}