
/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



#define _saturate(x, y, z) clamp(x, y, z)
#define _sqr(x) (x*x)
#define _pow5(x) x*x*x*x*x
#define _cubic_smooth(x, y, z) (x * x) * (y - (z * x))
#define _rcp(x, y) (y / x)
#define _log10(x, y) (log2(x) / log2(y))
#define coneAngleToSolidAngle(x) (tau*(1.0 - cos(x)))
#define length2(x) dot(x,x)
#define _sstep(x, low, high) smoothstep(low, high, x)
#define landMask(x) (x < 1.0)

#define lux(x) ((x) * 1e-2)

/* ------ lazyness macros ------ */
    #define gtex(x) texture(x, coord[0])    //for texture sampling in gbuffers
    #define stex(x) texture(x, coord)
    #define stexLod(x, lod) textureLod(x, coord, lod)
    #define crcp(x) (1.0 / x)

/* ------ matrix macros ------ */
    #define diagonal2(mat) vec2((mat)[0].x, (mat)[1].y)
    #define diagonal3(mat) vec3(diagonal2(mat), (mat)[2].z)
    #define diagonal4(mat) vec4(diagonal3(mat), (mat)[2].w)

    #define transMAD(mat, v) (mat3x3(mat) * (v) + (mat)[3].xyz)
    #define projMAD3(mat, v) (diagonal3(mat) * (v) + (mat)[3].xyz)

/* ------ optimized math macros ------ */
    #define expf(x) exp2((x) * rlog2)      //this should be faster than regular exp()