
/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



#include "/lib/fragment/academy/transforms.glsl"

vec3 SRGBtoLinear(vec3 x){
    vec3 temp = mix(x / 12.92, pow(.947867 * x + .0521327, vec3(2.4)), step(0.04045, x));
    return max(temp, 0.0);
}
vec3 LinearToSRGB(vec3 x){
    return mix(x * 12.92, pow(x, vec3(1./2.4)) * 1.055 - 0.055, step(0.0031308, x));
}

vec3 SRGBtoACEScg(vec3 x) {
    return SRGBtoLinear(x) * sRGB_AP1;
}

vec3 SRGBtoACEScgAlbedo(vec3 x) {
    return SRGBtoLinear(x) * sRGB_AP1_Albedo;
}