/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/

#include "/lib/universal.glsl"

/*
const bool colortex0MipmapEnabled = true;
*/

/* ------ outputs ------ */
out float exposure;

out vec2 coord;

/* ------ uniforms ------ */
uniform float frameTime;

uniform vec2 viewSize, pixelSize;

uniform sampler2D colortex0;
uniform sampler2D colortex5;

/* ------ includes ------ */
#include "/lib/atmosphere/constants.glsl"
#include "/lib/fragment/exposure.glsl"

void main() {
    gl_Position = vec4(gl_Vertex.xy * 2.0 - 1.0, 0.0, 1.0);
    coord       = gl_MultiTexCoord0.xy;
    exposure    = computeCameraExposure();
}