#version 450 compatibility

/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



#include "/lib/universal.glsl"


/* ------ outputs ------ */
out vec2 coord;

flat out vec3 atmosIlluminance;

/* ------ uniforms ------ */
uniform float eyeAltitude;

uniform vec2 viewSize;

uniform vec3 sunVector;
uniform vec3 moonVector;

/* ------ includes ------ */
#include "/lib/util/spectral.glsl"
#include "/lib/atmosphere/constants.glsl"
#include "/lib/atmosphere/transmittance.glsl"
#include "/lib/atmosphere/phase.glsl"
#include "/lib/atmosphere/calculate.glsl"

void main() {
    gl_Position     = vec4(gl_Vertex.xy * 2.0 - 1.0, 0.0, 1.0);
    coord           = gl_MultiTexCoord0.xy;

    atmosIlluminance = calculateAtmosphere(vec3(0.0, 1.0, 0.0), scatteringCoefficients, extinctionCoefficients, vec3(0.0), 16);
    atmosIlluminance = mix(atmosIlluminance, vec3(atmosIlluminance.b) * sqrt(2.0), 1.0 / pi);
}