#version 450 compatibility

/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/



#include "/lib/universal.glsl"

/* ------ framebuffer attachment outputs ------ */
/*DRAWBUFFERS:2*/
layout(location = 0) out vec4 auxiliary_data2;

/* ------ inputs from vertex stage ------ */
in mat2x2 coord;

in vec4 tint;

/* ------ uniforms ------ */
uniform sampler2D gcolor;


/* ------ includes ------ */
#include "/lib/util/srgb.glsl"
#include "/lib/util/encoders.glsl"

void main() {
    vec4 scenecol_data      = gtex(gcolor);
        scenecol_data.a    *= tint.a;
    if(scenecol_data.a < 0.33) discard;
        //scenecol_data.rgb   = vec3(v3avg(scenecol_data));

    auxiliary_data2         = vec4(encodeMatID16(301), 0.0, 0.0, 1.0);
}