#version 450 compatibility

/*
====================================================================================================
    __  __    __  ___    ____    ____ 
    \ \/ /   /  |/  /   /  _/   / __ \
     \  /   / /|_/ /    / /    / /_/ /
     / /   / /  / /   _/ /    / _, _/ 
    /_/   /_/  /_/   /___/   /_/ |_|  

    YMIR SHADERS

    Copyright (C) 2020 Jessie, RRe36, Niemand

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://github.com/ymir-graphics/ymir-releases/blob/master/LICENSE

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/




#include "/lib/universal.glsl"

/* ------ framebuffer attachment outputs ------ */
layout(location = 0) out vec4 scenecol_data;
layout(location = 1) out vec4 auxiliary_data;

/* ------ inputs from vertex stage ------ */
in mat2x2 coord;

flat in int is_water;

flat in vec3 normal;

flat in vec4 tint;

/* ------ uniforms ------ */
uniform int blockEntityId;

uniform sampler2D tex;

void water_customcolor(inout vec4 scenecol) {
    const vec3 watercol     = vec3(1.0, 1.0, 1.0);
    const float waterlum    = 0.2;
    const float opacity     = 0.12;

    scenecol.rgb    = watercol*waterlum;
    scenecol.a      = opacity;
}

void main() {
    if (blockEntityId == 10040) discard;

    scenecol_data      = gtex(tex);
    scenecol_data.rgb *= tint.rgb;
    if (is_water == 1) water_customcolor(scenecol_data);

    auxiliary_data     = vec4(normal * 0.5 + 0.5, coord[1].y * 0.5 + 0.5);
}